<template>
    <form @submit.prevent="updatePropertyFrom">
        <div class="space-y-8 py-4">
            <div class="border-b border-gray-900/10 pb-12">
                <h2 class="text-base font-semibold leading-7 text-gray-900">Add Property </h2>
                <div class="mt-10 grid grid-cols-1 gap-x-6 gap-y-8 sm:grid-cols-6">
                    <div class="sm:col-span-3">
                        <label for="first-name" class="block text-sm font-medium leading-6 text-gray-900">
                            Enter county
                        </label>
                        <div class="mt-2">
                            <input 
                            type="text" 
                            name="county" 
                            v-model="formData.county"
                            id="county" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <div class="sm:col-span-3">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                           Enter Number of bedrooms
                        </label>
                        <div class="mt-2">
                            <input 
                            type="text" 
                            name="num_bedrooms" 
                            v-model="formData.num_bedrooms"
                            id="num_bedrooms" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <div class="sm:col-span-3">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                           Enter Number of bathrooms
                        </label>
                        <div class="mt-2">
                            <input 
                            type="text" 
                            v-model="formData.num_bathrooms"
                            name="num_bathrooms" 
                            id="num_bathrooms" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <div class="sm:col-span-3">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                           Enter price
                        </label>
                        <div class="mt-2">
                            <input 
                            type="number" 
                            v-model="formData.price"
                            name="price" 
                            id="price" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <!-- need to map the data -->
                    <div class="sm:col-span-3">
                        <label for="property_type_id" class="block text-sm font-medium leading-6 text-gray-900">
                            Choose Property type
                        </label>
                        <div class="mt-2">
                            <select 
                            id="property_type_id" 
                            name="property_type_id"  
                            v-model="formData.property_type_id"
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
                                <option v-for="propertyType in propertyTypeList" :key="propertyType.id" :value="propertyType.id">
                                    {{ propertyType.title }}
                                </option>
                            </select>
                        </div>
                    </div>
                    
                    <div class="sm:col-span-3">
                        <legend class="text-sm text-gray-900">Type</legend>
                        <div class="mt-2 space-y-2">
                            <div class="flex items-center gap-x-3">
                                <input 
                                id="sale" 
                                name="type" 
                                v-model="formData.type" 
                                type="radio" 
                                value="sale"
                                class="h-4 w-4 border-gray-300 text-indigo-600 focus:ring-indigo-600" />
                                <label for="sale" class="block text-sm font-medium leading-6 text-gray-900">Sale</label>
                            </div>
                            <div class="flex items-center gap-x-3">
                                <input 
                                id="rent" 
                                name="type" 
                                type="radio" 
                                value="rent"
                                v-model="formData.type" 
                                class="h-4 w-4 border-gray-300 text-indigo-600 focus:ring-indigo-600" />
                                <label for="rent" class="block text-sm font-medium leading-6 text-gray-900">Rent</label>
                            </div>
                        </div>
                    </div>
                    <div class="sm:col-span-3">
                        <label for="about" class="block text-sm font-medium leading-6 text-gray-900">
                            Decsription
                        </label>
                            <div class="mt-2">
                                <textarea 
                                id="about" 
                                name="discription" 
                                v-model="formData.description"
                                rows="2" 
                                class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                            </div>
                    </div>
                </div>
            </div>
            <div class="pb-6">
                <h2 class="text-base font-semibold leading-7 text-gray-900">Address </h2>
                <div class="mt-10 grid grid-cols-1 gap-x-6 gap-y-8 sm:grid-cols-6">
                    <div class="sm:col-span-2">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                          Country
                        </label>
                        <div class="mt-2">
                            <input 
                            type="text" 
                            name="country" 
                            v-model="formData.country"
                            id="country" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>

                    <div class="sm:col-span-2">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                           Town
                        </label>
                        <div class="mt-2">
                            <input 
                            type="text" 
                            name="town" 
                            v-model="formData.town"
                            id="town" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>

                    <div class="sm:col-span-2">
                        <label for="last-name" class="block text-sm font-medium leading-6 text-gray-900">
                            ZIP / Postal code
                        </label>
                        <div class="mt-2">
                            <input 
                            type="text" 
                            name="post_code" 
                            v-model="formData.post_code"
                            id="post_code" 
                            class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                        </div>
                    </div>
                    <div class="col-span-full">
                        <label for="about" class="block text-sm font-medium leading-6 text-gray-900">
                            Enter Address
                        </label>
                            <div class="mt-2">
                                <textarea 
                                id="about" 
                                name="address"
                                v-model="formData.address"
                                rows="2" 
                                class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" />
                            </div>
                    </div>
                    <div class="col-span-full">
                        <label for="cover-photo" class="block text-sm font-medium leading-6 text-gray-900">
                            Upload Image
                        </label>
                        <div class="mt-2 flex justify-center rounded-lg border border-dashed border-gray-900/25 px-6 py-10">
                            <div class="text-center">
                                <PhotoIcon class="mx-auto h-12 w-12 text-gray-300" aria-hidden="true" />
                                <div class="mt-4 flex text-sm leading-6 text-gray-600">
                                    <label for="file-upload"
                                        class="relative cursor-pointer rounded-md bg-white font-semibold text-indigo-600 focus-within:outline-none focus-within:ring-2 focus-within:ring-indigo-600 focus-within:ring-offset-2 hover:text-indigo-500">
                                        <span>Upload a file</span>
                                       
                                    </label>
                                    <input 
                                        id="image_full" 
                                        name="image_full" 
                                        type="file" 
                                        @change="handlePropertyImageUpload"
                                        />
                                    
                                </div>
                               
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="mt-6 flex items-center justify-end gap-x-6 pb-12">
            <button type="button" class="text-sm font-semibold leading-6 text-gray-900">Cancel</button>
            <button type="submit"
                class="rounded-md bg-indigo-600 px-3 py-2 text-sm font-semibold text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600">Save</button>
        </div>
    </form>
</template>
  
<script setup>
 import { PhotoIcon } from '@heroicons/vue/24/solid'
 import { onMounted } from 'vue';
 import { usePropertyStore } from '../stores/property';
 const propertyStore = usePropertyStore();
 const propertyTypeList = ref([]);
 const route = useRoute()
 const id = route.params.id;

 const formData = ref({
    county: ref(''),
    num_bedrooms: ref(''),
    num_bathrooms: ref(''),
    price: ref(''),
    property_type_id: ref(''),
    description: ref(''),
    address: ref(''),
    image_full: ref(null),
    type: ref(''),
    country: ref(''),
    town: ref(''),
    post_code: ref(''),
 })

 const getPropertyType = async () => {
    await propertyStore.getPropertyTypes();
    propertyTypeList.value = propertyStore.propertyTypes;
}

 const getPropertyById = async (id) => {
    await propertyStore.getPropertyById(id);
    formData.value.county = propertyStore.property.county;
    formData.value.num_bedrooms = propertyStore.property.num_bedrooms;
    formData.value.num_bathrooms = propertyStore.property.num_bathrooms;
    formData.value.price = propertyStore.property.price;
    formData.value.property_type_id = propertyStore.property.property_type_id;
    formData.value.description = propertyStore.property.description;
    formData.value.address = propertyStore.property.address;
    formData.value.type = propertyStore.property.type;
    formData.value.country = propertyStore.property.country;
    formData.value.town = propertyStore.property.town;
    formData.value.post_code = propertyStore.property.post_code;
    
}

const handlePropertyImageUpload = (e) =>{
    const file = e.target.files[0];
    formData.value.image_full = file;
}
const updatePropertyFrom = async () =>{
    console.log('form data',formData.value);
    const newFormData = new FormData();
    newFormData.append('county', formData.value.county);
    newFormData.append('num_bedrooms', formData.value.num_bedrooms);
    newFormData.append('num_bathrooms', formData.value.num_bathrooms);
    newFormData.append('price', formData.value.price);
    newFormData.append('property_type_id', formData.value.property_type_id);
    newFormData.append('description', formData.value.description);
    newFormData.append('type', formData.value.type);
    newFormData.append('address', formData.value.address);
    newFormData.append('country', formData.value.country);
    newFormData.append('town', formData.value.town);
    newFormData.append('post_code', formData.value.post_code);
    if (formData.value.image_full) {
        newFormData.append('image_full', formData.value.image_full);
    }
    await propertyStore.updateProperty(id,newFormData);
    await navigateTo('/')
}
onMounted(() => {
    getPropertyType();
    getPropertyById(id);

})

</script>